/**
 * @file DllFileFunc.cpp
 * @brief t@C֘ADLL֐̎
 * @author Shinji Watanabe
 * @version 1.0
 * @note DllMain.cppړ
 * @date Oct.01.2007
 */

#include "ConvFactory.h"
#include "CharsetDetector.h"

/**
 * TextFromFile
 * @brief w肳ꂽt@C|C^t@Cǂݍ݂܂B
 * @param nID WJFootyIDԍ
 * @param pFile WJt@C|C^
 * @param nCharSets ǂݍރLN^Zbg
 */
static int TextFromFile(int nID,FILE *pFile,CharSetMode nCharSets){
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;

	// t@C̒擾
	UINT nFileSize;
	fseek(pFile,0,SEEK_END);
	nFileSize=ftell(pFile);
	fseek(pFile,0,SEEK_SET);
	
	if (nFileSize == 0){
		// t@CȂVK쐬
		Footy2CreateNew(nID);
	}
	else{
		// t@C琶f[^擾
		std::vector<char> vecRawData;
		vecRawData.assign(nFileSize,'\0');
		fread(&vecRawData[0],nFileSize,1,pFile);

		// eLXgRo[^[pӂ
		if (nCharSets == CSM_AUTOMATIC){
			CCharsetDetector cDetector;
			cDetector.Detect(&vecRawData[0],nFileSize);
			nCharSets = cDetector.GetCodepage();
		}
		CConvFactory cConvFactory(nCharSets);
		if (!cConvFactory.GetConv())return FOOTY2ERR_ENCODER;

		// eLXgϊđ
		if (!cConvFactory.GetConv()->ToUnicode(&vecRawData[0],nFileSize)){
			fclose(pFile);
			return FOOTY2ERR_MEMORY;
		}
		pFooty->SetText((const wchar_t*)cConvFactory.GetConv()->GetConvData());
		pFooty->SetCharSet(cConvFactory.GetCharset());
	}
	
	// t@C
	fclose(pFile);
	return FOOTY2ERR_NONE;
}

/**
 * SaveToFile
 * @brief w肳ꂽt@Cɕۑ鏈
 * @param nID f[^FootyID
 * @param pFile ݐt@C|C^
 * @param nCharSets ݃LN^Zbg
 * @param nLineMode ݉sR[h
 */
static int SaveToFile(int nID,FILE *pFile,CharSetMode nCharSets,int nLineMode){
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;

	// w肵Footyf[^擾
	int nLength = Footy2GetTextLengthW(nID,nLineMode);
	wchar_t *pTexts = new wchar_t[nLength+1];
	Footy2GetTextW(nID,pTexts,nLineMode,nLength+1);

	// eLXgRo[^[pӂ
	if (nCharSets == CSM_AUTOMATIC)
		nCharSets = pFooty->GetCharSet();
	CConvFactory cConvFactory(nCharSets);
	if (!cConvFactory.GetConv())return FOOTY2ERR_ENCODER;
	if (!cConvFactory.GetConv()->ToMulti(pTexts,nLength)){
		if (pTexts){
			delete [] pTexts;
			pTexts = NULL;
		}
		fclose(pFile);
		return FOOTY2ERR_MEMORY;
	}
	fwrite(cConvFactory.GetConv()->GetConvData(),					// ϊۑ
		   cConvFactory.GetConv()->GetConvTextSize()-sizeof(char),	// NULL͕ۑȂ
		   1,pFile);												// nꂽt@C|C^֏

	// Z[uۑĂ
	pFooty->m_cDoc.SetSavePoint();

	// 
	if (pTexts){
		delete [] pTexts;
		pTexts = NULL;
	}
	fclose(pFile);
	return FOOTY2ERR_NONE;
}

/**
 * Footy2SaveToFileW
 * @brief t@C֕ۑ܂
 * @param nID ǂݍFootyID
 * @param pPath ǂݍރt@C
 * @param nCharSets LN^Zbg
 * @param nLineMode sR[h
 */
FOOTYEXPORT(int)Footy2SaveToFileW(int nID,const wchar_t *pPath,int nCharSets,int nLineMode){
	// t@C̓oCi[hWJ
	FILE *pFile = NULL;
#ifdef UNDER_CE
	pFile = _wfopen(pPath, L"wb");
#else	/*UNDER_CE*/
	_wfopen_s(&pFile, pPath, L"wb");
#endif	/*UNDER_CE*/

	// t@CWJłȂ
	if (!pFile)return FOOTY2ERR_404;

	// t@C֕ۑ
	return SaveToFile(nID,pFile,(CharSetMode)nCharSets,nLineMode);
}

/**
 * Footy2TextFromFileW
 * @brief t@Cǂݍ݂܂
 * @param pPath ǂݍ݌t@CpX
 * @param nCharSets LN^Zbg
 */
FOOTYEXPORT(int)Footy2TextFromFileW(int nID,const wchar_t *pPath,int nCharSets){
	// t@C̓oCi[hWJ
	FILE *pFile = NULL;
#ifdef UNDER_CE
	pFile = _wfopen(pPath, L"rb");
#else	/*UNDER_CE*/
	_wfopen_s(&pFile, pPath, L"rb");
#endif	/*UNDER_CE*/

	// t@CJȂ
	if (!pFile)return FOOTY2ERR_404;

	// t@CJ
	return TextFromFile(nID,pFile,(CharSetMode)nCharSets);
}

#ifndef UNDER_CE
/**
 * Footy2SaveToFileA
 * @brief t@C֏݂܂
 * @param pPath ݐt@CpX
 * @param nCharSets ݕR[h
 * @param nLineMode ݉sR[h
 */
FOOTYEXPORT(int)Footy2SaveToFileA(int nID,const char *pPath,int nCharSets,int nLineMode){
	// t@C̓oCi[hWJ
	FILE *pFile = NULL;
	fopen_s(&pFile, pPath, "wb");

	// t@CփANZXoȂ
	if (!pFile)return FOOTY2ERR_404;

	// t@Cۑ
	return SaveToFile(nID,pFile,(CharSetMode)nCharSets,nLineMode);
}

/**
 * Footy2TextFromFileA
 * @brief t@Cǂݍ݂܂
 * @param nID ǂݍݐFootyID
 * @param pPath ǂݍ݂ƃt@CpX
 * @param nCharSets LN^Zbg
 */
FOOTYEXPORT(int)Footy2TextFromFileA(int nID,const char *pPath,int nCharSets){
	// t@C̓oCi[hWJ
	FILE *pFile = NULL;
	fopen_s(&pFile, pPath, "rb");

	// t@CփANZXoȂ
	if (!pFile)return FOOTY2ERR_404;

	// t@Cǂݍ
	return TextFromFile(nID,pFile,(CharSetMode)nCharSets);
}

#endif	/*UNDER_CE*/



/*[EOF]*/
