/**
 * @file Footy.h
 * @brief FootyGfB^̂߂̃NXBɈ̃hLg4̃r[ێ܂
 * @author Shinji Watanabe
 * @date Nov.08.2008
 */

#pragma once

#include "FootyDoc.h"
#include "VSplitter.h"
#include "HSplitter.h"

class CFooty
{
public:
	CFooty(int nID, HINSTANCE hInstance, int nViewMode );

	// \bh
	bool Create(HWND hWnd, int x,int y,int nWidth,int nHeight);
	void ChangeView(int nViewMode,bool bRedraw = false);
	bool Move(int x,int y,int nWidth,int nHeight);
	void SetText(const wchar_t *pString);
	bool SetSelText(const wchar_t *pString);
	bool Paste();
	bool Copy();
	bool Cut();
	bool Undo();
	bool Redo();
	
	// tHgݒ
	bool SetFontSize(int nPoint,bool bRedraw);
	bool SetFontFace(int nType,const wchar_t *pFaceName,bool bRedraw);
	bool SetForceFont(int flag);	// tHg̋gp by inovia
	bool SetSpeedDraw(int flag);	// ` by inovia
	
	// ܂Ԃݒ
	bool SetLapel(int nColumns,int nMode,bool bRedraw);
	inline void SetCharSet(CharSetMode nCharSet){m_nCharSet = nCharSet;}
	
	// 擾
	inline int GetID() const {return m_nID;}
	inline CharSetMode GetCharSet() const {return m_nCharSet;}
	bool IsFocused();

public:
	// f[^
	CFootyDoc m_cDoc;					//!< hLg
	CFootyStatus m_cStatus;				//!< Xe[^XNX
	
	// GUI
	CFootyView m_cView[4];				//!< r[NX
	CVSplitter m_cVSplitter;			//!< Xvb^[
	CHSplitter m_cHSplitter;			//!< Xvb^[
	
private:
	// IDf[^
	int m_nID;							//!< Footy2ID
	CharSetMode m_nCharSet;				//!< ݐݒ肳ĂLN^Zbg
	LineMode m_nLineCode;

	// f[^
	HWND m_hWndParent;					//!< eEBhEnh
	HINSTANCE m_hInstance;				//!< DLL̃CX^X
	int m_x,m_y;						//!< ʒu
	int m_nWidth,m_nHeight;				//!< 傫
	int m_nViewMode;					//!< r[
	CFontObjects m_cFonts;				//!< tHgIuWFNg
	
};

/*[EOF]*/
